#include <windows.h>
#include <stdio.h>

#define BOF_SIZE 5000
#define NB_ARG_LIMIT 5
#define MAX_SIZE 255

extern BOOL WINAPI DebugActiveProcessStop(DWORD dwProcessId);

VOID FuzzFunction(PUCHAR szFunction, UINT nbArg);
VOID DumpRegisters(HANDLE hThread);
BYTE Test(PUCHAR szReq, PEXCEPTION_RECORD pExceptionInfo);

int main()
{
   
   UCHAR buf[MAX_SIZE+1];
   FILE *fp = NULL;
   UINT Total = 0;
   UINT Tested = 0;
   UCHAR szTitle[256+1];
   
   printf("\nLilxam's PHP fuzzer\n");
    
   ShellExecute(NULL, "open","php", " -f fuzzer.php", NULL, SW_NORMAL);
    
   Sleep(3000);
    
   fp = fopen("functions.txt", "r");
    
    if(fp != NULL)
    {
        while(fgets(buf, MAX_SIZE, fp))
            Total++;
        
        fseek(fp, 0, SEEK_SET);


        while(fgets(buf, MAX_SIZE, fp))
        {
            FuzzFunction(buf, 1);    
            ZeroMemory(&buf, sizeof(buf));
            Tested++;
            sprintf(szTitle, "%ld/%ld functions tested : %ld%% done.", Tested, Total, (int)round((double)100*((double)Tested/Total)));
            SetConsoleTitle(szTitle);
            if((int)(Tested%1000) == 0)
                                 Sleep(5*60*1000); // Pause 5 minuts
        }
    }
    printf("\nEnd of fuzz.");
    
    getchar();
    return EXIT_SUCCESS; 
}
VOID FuzzFunction(PUCHAR szFunction, UINT nbArg)
{
    EXCEPTION_RECORD ExceptionInfo = {0x0};
    
    FILE *hLog = NULL;
    
    PUCHAR szReq = NULL;;
    UCHAR szBof[BOF_SIZE+1];
    
    size_t i;
    
    
    
    memset(szBof, 0x41, BOF_SIZE);
    szReq = (PUCHAR)calloc((nbArg+1)*BOF_SIZE, sizeof(UCHAR));
    
    sprintf(szReq, "php -r %s('%s'", szFunction, szBof);
    
    for(i = 1; i < nbArg; i++)
    {
          strcat(szReq, ",'");
          strcat(szReq, szBof);
          strcat(szReq, "'");
    }
    strcat(szReq, ");");

    /* Check for a bug */

    if(Test(szReq, &ExceptionInfo))
    {
         printf("[!] Bug (code : 0x%x) at 0x%x with %s", ExceptionInfo.ExceptionCode, ExceptionInfo.ExceptionAddress, szFunction);
         
         hLog = fopen("Log.txt", "a+");
         if(hLog != NULL)
                 fprintf(hLog, "[!] Bug (code : 0x%x) at 0x%x with %s", ExceptionInfo.ExceptionCode, ExceptionInfo.ExceptionAddress, szFunction);
         
         fclose(hLog);
         return;
    }
    else if(nbArg < NB_ARG_LIMIT)
         FuzzFunction(szFunction, nbArg+1);
         
   return;
}
BYTE Test(PUCHAR szReq, PEXCEPTION_RECORD pExceptionInfo)
{
    DWORD BUG = 0x0;
    STARTUPINFO si = {0x0};
    PROCESS_INFORMATION pi = {0x0};
    DEBUG_EVENT DebugEvent;

    EXCEPTION_DEBUG_INFO ExceptDbgInfo;
    EXCEPTION_RECORD ExceptRecord;
    PEXCEPTION_RECORD pRetExceptRecord = NULL;
    
    //printf("Starting Process...");
    
    if(!CreateProcess("php.exe", szReq, NULL, NULL, FALSE, DEBUG_ONLY_THIS_PROCESS|DETACHED_PROCESS, NULL, NULL, &si, &pi))
    {
        printf("FAILED to execute php.exe : 0x%x\n\n", GetLastError());
        return 0x0;
    }

    //printf("OK");
    
    DebugActiveProcess(pi.dwProcessId);
    
    //printf("\nDebugging Process (ID : 0x%x)...\n\n", pi.dwProcessId);
    
    while(1)
    {

       WaitForDebugEvent(&DebugEvent, INFINITE);
       if(DebugEvent.dwDebugEventCode ==  EXCEPTION_DEBUG_EVENT)
       {
            
             ExceptDbgInfo = DebugEvent.u.Exception;
             ExceptRecord = ExceptDbgInfo.ExceptionRecord;
             
             
             
             if(ExceptRecord.ExceptionCode != 0x80000003)
             {
                    pExceptionInfo->ExceptionAddress = ExceptRecord.ExceptionAddress;
                    pExceptionInfo->ExceptionCode = ExceptRecord.ExceptionCode;
                    
                    BUG = 0x1;
                    break;
             }
       }
       else if(DebugEvent.dwDebugEventCode == EXIT_PROCESS_DEBUG_EVENT)
       {
                  // printf("\n\nProcess exited %ld\n\n", GetLastError());
                  break;
       }
       ContinueDebugEvent(DebugEvent.dwProcessId, DebugEvent.dwThreadId, DBG_CONTINUE);
   }
   
    DebugActiveProcessStop(pi.dwProcessId);
    TerminateProcess(pi.hProcess, 0x0);
    
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
    return BUG;

}
VOID DumpRegisters(HANDLE hThread)
{
     CONTEXT Context;
	 Context.ContextFlags = CONTEXT_FULL;
	
     SuspendThread(hThread);
     
     GetThreadContext(hThread, &Context);
     
     printf("\n\n        ***** REGISTERS *****\n");
    printf("\n  EAX : 0x%x ---> %d", Context.Eax, Context.Eax);
    printf("\n  EBX : 0x%x ---> %d", Context.Ebx, Context.Ebx);
    printf("\n  ECX : 0x%x ---> %d", Context.Ecx, Context.Ecx);
    printf("\n  EDX : 0x%x ---> %d", Context.Edx, Context.Edx);
    printf("\n  ESI : 0x%x ---> %d", Context.Esi, Context.Esi);
    printf("\n  EDI : 0x%x ---> %d", Context.Edi, Context.Edi);
    printf("\n  EBP : 0x%x ---> %d", Context.Ebp, Context.Ebp);
    printf("\n  ESP : 0x%x ---> %d", Context.Esp, Context.Esp);
    printf("\n\n  EIP : 0x%x ---> %d", Context.Eip, Context.Eip);
    
                
    ResumeThread(hThread);
}
